//	declare global variables
//	var debug = true;
	var debug = false;
	
	var eventsContainerObj;
	var eventsObj;
	var dateObj;
	var myScrollBarObj;
	var myScrollTrackObj;
	var myScrollThumbObj;
	var textObj;
	var itemsHTML;
	var rssURL = "http://modis.gsfc.nasa.gov/rss/widget.xml";
	var days = new Array("Sun","Mon","Tue","Wed","Thu","Fri","Sat");
	var mons = new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
	
	var msgs = new Array();
	msgs["noconnection"]	= '<div class="error">Unable to retrieve events. Please check to make sure you are connected to the Internet.<\/div>';
	msgs["emptyfeed"]		= '<div class="error">Events feed empty.<\/div>';
	msgs["loading"]			= '<div class="message">Updating events. Please wait.<\/div>';
	msgs["loaded"]			= '<div class="message">Events loaded.<\/div>';
	
	var tag1 = '<div id="title" class="textFontHeader">';
	var tag2 = '</div>';
	var tag3_1 = '<div id="imageOfTheDay" class="textFont"><a href="#" onclick=\'widget.openURL("';
	var tag3_2 = '")\';><img src="http://modis.gsfc.nasa.gov/gallery/images/';
	var tag4 = '"></a></div>';
	var tag5 = '<div id="imgCredit" class="textFont"><span class="textFontHeader">Image Credit:</span><br>';
	var tag6 = '</div>';
	var tag7 = '<div id="dateAcquired" class="textFont"><span class="textFontHeader">Date Acquired:</span><br>';
	var tag8 = '</div>';
	var tag9 = '<div id="bandsUsed" class="textFont"><span class="textFontHeader">Bands Used:</span><br>';
	var tag10 = '</div>';
	var tag11 = '<div id="text" class="textFont">'
	var tag12 = '</div>';

	var gDoneButton;
	var gInfoButton;
	var gMyScrollArea, gMyScrollbar;

 

	function setup()	{
		gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hideBack);
		gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showBack);
		gMyScrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollbar"));
		gMyScrollArea = new AppleScrollArea(document.getElementById("myScrollArea"));
		gMyScrollArea.addScrollbar(gMyScrollbar);
	}
		
	function init() {
	
		setup();
		eventsContainerObj	= getObj("eventsContainer");
		eventsObj			= getObj("events");
		dateObj				= getObj("date");
		myScrollAreaObj		= getObj("myScrollArea");
		textObj				= getObj("text");	
		getNewEvents();

	}
	
	function getNewEvents() {
			loadXML(rssURL);
	
	}
	
	function loadXML(url) {
		 xmlRequest = new XMLHttpRequest();
		 xmlRequest.setRequestHeader("Cache-Control", "no-cache");
		 xmlRequest.onreadystatechange = processRequestChange;
		 xmlRequest.open("GET",url,true);
		 xmlRequest.send(null);
	}
	
	function processRequestChange() {	
		if (null == xmlRequest.readyState) return;
		if (xmlRequest.readyState == 4) {
			if (xmlRequest.status == 200) {		
				displayMsg("loaded");
				parseRSS();
			} else {
				if (null == xmlRequest.status) return;
				displayMsg("noconnection");
			}
		}
	}
	
	function parseRSS() {
		if (null == xmlRequest.responseXML) {
			displayMsg("emptyfeed");
		} 
		else {
			xml = xmlRequest.responseXML;
			
			htmlBody = "";
			items = xml.getElementsByTagName("item");
			for (var i = 0; i < items.length; i++) {
				htmlBody += addItem(items[i]);
			}
			eventsObj.innerHTML = htmlBody;
		
		}
	}
	
	function addItem(item) {
		var title		= item.childNodes[1].firstChild.nodeValue;
		var link		= item.childNodes[3].firstChild.nodeValue;
		var image		= item.childNodes[5].firstChild.nodeValue;
		var imageCredit = item.childNodes[7].firstChild.nodeValue;
		var dateAcquired= item.childNodes[9].firstChild.nodeValue;
		var bandsUsed	= item.childNodes[11].firstChild.nodeValue;
		var text		= item.childNodes[13].firstChild.nodeValue;
		

		htmlBody = tag1;
		htmlBody += title;
		htmlBody += tag2;
		htmlBody += tag3_1;
		htmlBody += link;
		htmlBody += tag3_2;
		htmlBody += image;
		htmlBody += tag4;
		htmlBody += tag7;
		htmlBody += dateAcquired;
		htmlBody += tag8;
		htmlBody += tag9;
		htmlBody += bandsUsed;
		htmlBody += tag10;
		addText(item);
		
		return htmlBody;
	}
	
	function addText(item) {
		var text = item.childNodes[13].firstChild.nodeValue;
		textBody = text;
		myScrollArea.innerHTML = textBody;
	}

	
	// LIBRARY FUNCTIONS
	function toggleDescription(id) {
		var desObj = getObj("description"+id);
		var imgObj = getObj("img"+id);
		
		if (desObj.style.display == "none") {
			desObj.style.display = "block";
			imgObj.src = "images/arrow_open.gif";
		} else {
			desObj.style.display = "none";
			imgObj.src = "images/arrow_closed.gif";
		}
		setScroller();
	}
	
	function displayMsg(msgId) {
		eventsObj.innerHTML = msgs[msgId];
	}
	
	function formatDate(ds) {
		// if we're getting a full date string, reduce it to "DD MMM YYYY" due to a parsing bug in Safari
		if (ds.length > 11) {
			ds = ds.substring(5);
			ds = ds.substring(0,11);
		}
		
		var today = new Date(ds);
		formattedDate = days[today.getDay()] + " " + mons[today.getMonth()] + " " + today.getDate() + ", " + today.getFullYear();
		
		return formattedDate;
	}
	
	function gotoURL(url) {
		if (window.widget) {
			widget.openURL(url)
		} else {
			location.href = url;
		}
	}
	
	// No track/key timers should be running while Dashboard is hidden.
	function onHide () {
		clearTimer();
	}
	
	function getObj(id) {
		return document.getElementById(id);
	}
	
	// EVENT HANDLERS
	window.onload = init;
	
	if (window.widget) {
		widget.onshow = getNewEvents;
		widget.onhide = onHide;
	}
	
	// DEBUGGING FUNCTION
	function writeDebug(s) {
		if (window.widget) {
			alert(s);
		} else {
			document.getElementById("debug").innerHTML += s + "<br />\n";
		}
	}
	
	
	/*******************/
/* APPLE FUNCTIONS */

function showBack() { 
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget) widget.prepareForTransition("ToBack");
	front.style.display="none";
	back.style.display="block";
	if (window.widget) setTimeout ("widget.performTransition()", 0); 
}

function hideBack() { 
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget) widget.prepareForTransition("ToFront");
	back.style.display="none";
	front.style.display="block";
	if (window.widget) setTimeout ("widget.performTransition()", 0);
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, secondElement:null, timer:null};

function mousemove(event) { 
	if (!flipShown) { 
		if (animation.timer != null) { 
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ("flip");
		animation.timer = setInterval ("animate()", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}
 
function mouseexit(event) { 
	if (flipShown) { 
		// fade in the info button 
		if (animation.timer != null) { 
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById("flip");
		animation.timer = setInterval ("animate()", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}
 
function animate() { 
	var T;
	var ease;
	var time = (new Date).getTime();
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration) { 
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	} else { 
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c) { 
	return a < b ? b : (a > c ? c : a);
}
 
function computeNextFloat (from, to, ease) { 
	return from + (to - from) * ease;
}

function enterflip(event) { 
	document.getElementById("fliprollie").style.display = "block";
} 

function exitflip(event) { 
	document.getElementById("fliprollie").style.display = "none";
}

